require 'temple/html/safe'
module Frozen
  module Environment
    class Base
      attr_accessor :view
      def initialize(view)
        @view = view
      end

      def current_page
        view.build_file_path
      end

      def current_page?(path)
        current_page == path
      end

      def stylesheet(name)
        name << ".css" unless File.basename(name) == ".css"
        name = "#{view.relative_to_root}/css/#{name}"
        %Q|<link href="#{name}" rel="stylesheet" type="text/css"/>|.html_safe
      end

      def javascript(name)
        name << ".js" unless File.basename(name) == ".js"
        name = "#{view.relative_to_root}/js/#{name}"
        %Q|<script src="#{name}" language="javascript"></script>|
      end

      def html_safe?
        true
      end

    end
  end
end
