require 'frozen/template/base'
require 'uglifier'
require 'coffee-script'

module Frozen
  module Template
    class Javascript < Base
      attr_accessor :options
      attr_accessor :file_load_path

      def initialize(options={})
        @options = {
          :style => :compressed,
          :format => nil,
          :load_path => nil
        }.merge(options)
      end

      def read_from_file(file)
        self.file_load_path = File.dirname(file)
        super(file)
      end

      def contents
        read_from_file(file_path)
      end

      def build_extension
        ".js"
      end

      def build_path
        "js"
      end

      def render
        js = ""
        js = CoffeeScript.compile(contents) if file_type == "coffee"
        js = contents if file_type == "js"
        Uglifier.new.compile(js)
      end
    end
  end
end
